builtin-remote: fix two inconsistencies in the output of "show <remote>"
[git/dscho.git] / git-rebase.sh
blob368c0ef4342df990a5617fd6fbe2cd973b1b208b
1 #!/bin/sh
3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE='[--interactive | -i] [-v] [--onto <newbase>] [<upstream>|--root] [<branch>]'
7 LONG_USAGE='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .git/rebase-apply working files, use the
18 command git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
26 / --> /
27 D---E---F---G master D---E---F---G master
30 SUBDIRECTORY_OK=Yes
31 OPTIONS_SPEC=
32 . git-sh-setup
33 set_reflog_action rebase
34 require_work_tree
35 cd_to_toplevel
37 OK_TO_SKIP_PRE_REBASE=
38 RESOLVEMSG="
39 When you have resolved this problem run \"git rebase --continue\".
40 If you would prefer to skip this patch, instead run \"git rebase --skip\".
41 To restore the original branch and stop rebasing run \"git rebase --abort\".
43 unset newbase
44 strategy=recursive
45 do_merge=
46 dotest="$GIT_DIR"/rebase-merge
47 prec=4
48 verbose=
49 git_am_opt=
50 rebase_root=
52 continue_merge () {
53 test -n "$prev_head" || die "prev_head must be defined"
54 test -d "$dotest" || die "$dotest directory does not exist"
56 unmerged=$(git ls-files -u)
57 if test -n "$unmerged"
58 then
59 echo "You still have unmerged paths in your index"
60 echo "did you forget to use git add?"
61 die "$RESOLVEMSG"
64 cmt=`cat "$dotest/current"`
65 if ! git diff-index --quiet --ignore-submodules HEAD --
66 then
67 if ! git commit --no-verify -C "$cmt"
68 then
69 echo "Commit failed, please do not call \"git commit\""
70 echo "directly, but instead do one of the following: "
71 die "$RESOLVEMSG"
73 printf "Committed: %0${prec}d " $msgnum
74 else
75 printf "Already applied: %0${prec}d " $msgnum
77 git rev-list --pretty=oneline -1 "$cmt" | sed -e 's/^[^ ]* //'
79 prev_head=`git rev-parse HEAD^0`
80 # save the resulting commit so we can read-tree on it later
81 echo "$prev_head" > "$dotest/prev_head"
83 # onto the next patch:
84 msgnum=$(($msgnum + 1))
85 echo "$msgnum" >"$dotest/msgnum"
88 call_merge () {
89 cmt="$(cat "$dotest/cmt.$1")"
90 echo "$cmt" > "$dotest/current"
91 hd=$(git rev-parse --verify HEAD)
92 cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
93 msgnum=$(cat "$dotest/msgnum")
94 end=$(cat "$dotest/end")
95 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
96 eval GITHEAD_$hd='$(cat "$dotest/onto_name")'
97 export GITHEAD_$cmt GITHEAD_$hd
98 git-merge-$strategy "$cmt^" -- "$hd" "$cmt"
99 rv=$?
100 case "$rv" in
102 unset GITHEAD_$cmt GITHEAD_$hd
103 return
106 git rerere
107 die "$RESOLVEMSG"
110 echo "Strategy: $rv $strategy failed, try another" 1>&2
111 die "$RESOLVEMSG"
114 die "Unknown exit code ($rv) from command:" \
115 "git-merge-$strategy $cmt^ -- HEAD $cmt"
117 esac
120 move_to_original_branch () {
121 test -z "$head_name" &&
122 head_name="$(cat "$dotest"/head-name)" &&
123 onto="$(cat "$dotest"/onto)" &&
124 orig_head="$(cat "$dotest"/orig-head)"
125 case "$head_name" in
126 refs/*)
127 message="rebase finished: $head_name onto $onto"
128 git update-ref -m "$message" \
129 $head_name $(git rev-parse HEAD) $orig_head &&
130 git symbolic-ref HEAD $head_name ||
131 die "Could not move back to $head_name"
133 esac
136 finish_rb_merge () {
137 move_to_original_branch
138 rm -r "$dotest"
139 echo "All done."
142 is_interactive () {
143 while test $# != 0
145 case "$1" in
146 -i|--interactive)
147 interactive_rebase=explicit
148 break
150 -p|--preserve-merges)
151 interactive_rebase=implied
153 esac
154 shift
155 done
157 if [ "$interactive_rebase" = implied ]; then
158 GIT_EDITOR=:
159 export GIT_EDITOR
162 test -n "$interactive_rebase" || test -f "$dotest"/interactive
165 run_pre_rebase_hook () {
166 if test -z "$OK_TO_SKIP_PRE_REBASE" &&
167 test -x "$GIT_DIR/hooks/pre-rebase"
168 then
169 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} || {
170 echo >&2 "The pre-rebase hook refused to rebase."
171 exit 1
176 test -f "$GIT_DIR"/rebase-apply/applying &&
177 die 'It looks like git-am is in progress. Cannot rebase.'
179 is_interactive "$@" && exec git-rebase--interactive "$@"
181 if test $# -eq 0
182 then
183 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply || usage
184 test -d "$dotest" -o -f "$GIT_DIR"/rebase-apply/rebasing &&
185 die 'A rebase is in progress, try --continue, --skip or --abort.'
186 die "No arguments given and $GIT_DIR/rebase-apply already exists."
189 while test $# != 0
191 case "$1" in
192 --no-verify)
193 OK_TO_SKIP_PRE_REBASE=yes
195 --continue)
196 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
197 die "No rebase in progress?"
199 git diff-files --quiet --ignore-submodules || {
200 echo "You must edit all merge conflicts and then"
201 echo "mark them as resolved using git add"
202 exit 1
204 if test -d "$dotest"
205 then
206 prev_head=$(cat "$dotest/prev_head")
207 end=$(cat "$dotest/end")
208 msgnum=$(cat "$dotest/msgnum")
209 onto=$(cat "$dotest/onto")
210 continue_merge
211 while test "$msgnum" -le "$end"
213 call_merge "$msgnum"
214 continue_merge
215 done
216 finish_rb_merge
217 exit
219 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
220 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
221 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
222 git am --resolved --3way --resolvemsg="$RESOLVEMSG" &&
223 move_to_original_branch
224 exit
226 --skip)
227 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
228 die "No rebase in progress?"
230 git reset --hard HEAD || exit $?
231 if test -d "$dotest"
232 then
233 git rerere clear
234 prev_head=$(cat "$dotest/prev_head")
235 end=$(cat "$dotest/end")
236 msgnum=$(cat "$dotest/msgnum")
237 msgnum=$(($msgnum + 1))
238 onto=$(cat "$dotest/onto")
239 while test "$msgnum" -le "$end"
241 call_merge "$msgnum"
242 continue_merge
243 done
244 finish_rb_merge
245 exit
247 head_name=$(cat "$GIT_DIR"/rebase-apply/head-name) &&
248 onto=$(cat "$GIT_DIR"/rebase-apply/onto) &&
249 orig_head=$(cat "$GIT_DIR"/rebase-apply/orig-head) &&
250 git am -3 --skip --resolvemsg="$RESOLVEMSG" &&
251 move_to_original_branch
252 exit
254 --abort)
255 test -d "$dotest" -o -d "$GIT_DIR"/rebase-apply ||
256 die "No rebase in progress?"
258 git rerere clear
259 if test -d "$dotest"
260 then
261 move_to_original_branch
262 else
263 dotest="$GIT_DIR"/rebase-apply
264 move_to_original_branch
266 git reset --hard $(cat "$dotest/orig-head")
267 rm -r "$dotest"
268 exit
270 --onto)
271 test 2 -le "$#" || usage
272 newbase="$2"
273 shift
275 -M|-m|--m|--me|--mer|--merg|--merge)
276 do_merge=t
278 -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
279 --strateg=*|--strategy=*|\
280 -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
281 case "$#,$1" in
282 *,*=*)
283 strategy=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
284 1,*)
285 usage ;;
287 strategy="$2"
288 shift ;;
289 esac
290 do_merge=t
292 -v|--verbose)
293 verbose=t
295 --whitespace=*)
296 git_am_opt="$git_am_opt $1"
298 -C*)
299 git_am_opt="$git_am_opt $1"
301 --root)
302 rebase_root=t
305 usage
308 break
310 esac
311 shift
312 done
313 test $# -gt 2 && usage
315 # Make sure we do not have $GIT_DIR/rebase-apply
316 if test -z "$do_merge"
317 then
318 if mkdir "$GIT_DIR"/rebase-apply 2>/dev/null
319 then
320 rmdir "$GIT_DIR"/rebase-apply
321 else
322 echo >&2 '
323 It seems that I cannot create a rebase-apply directory, and
324 I wonder if you are in the middle of patch application or another
325 rebase. If that is not the case, please
326 rm -fr '"$GIT_DIR"'/rebase-apply
327 and run me again. I am stopping in case you still have something
328 valuable there.'
329 exit 1
331 else
332 if test -d "$dotest"
333 then
334 die "previous rebase directory $dotest still exists." \
335 'Try git rebase (--continue | --abort | --skip)'
339 # The tree must be really really clean.
340 if ! git update-index --ignore-submodules --refresh; then
341 echo >&2 "cannot rebase: you have unstaged changes"
342 exit 1
344 diff=$(git diff-index --cached --name-status -r --ignore-submodules HEAD --)
345 case "$diff" in
346 ?*) echo >&2 "cannot rebase: your index contains uncommitted changes"
347 echo >&2 "$diff"
348 exit 1
350 esac
352 if test -z "$rebase_root"
353 then
354 # The upstream head must be given. Make sure it is valid.
355 upstream_name="$1"
356 shift
357 upstream=`git rev-parse --verify "${upstream_name}^0"` ||
358 die "invalid upstream $upstream_name"
359 unset root_flag
360 upstream_arg="$upstream_name"
361 else
362 test -z "$newbase" && die "--root must be used with --onto"
363 unset upstream_name
364 unset upstream
365 root_flag="--root"
366 upstream_arg="$root_flag"
369 # Make sure the branch to rebase onto is valid.
370 onto_name=${newbase-"$upstream_name"}
371 onto=$(git rev-parse --verify "${onto_name}^0") || exit
373 # If a hook exists, give it a chance to interrupt
374 run_pre_rebase_hook "$upstream_arg" "$@"
376 # If the branch to rebase is given, that is the branch we will rebase
377 # $branch_name -- branch being rebased, or HEAD (already detached)
378 # $orig_head -- commit object name of tip of the branch before rebasing
379 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
380 switch_to=
381 case "$#" in
383 # Is it "rebase other $branchname" or "rebase other $commit"?
384 branch_name="$1"
385 switch_to="$1"
387 if git show-ref --verify --quiet -- "refs/heads/$1" &&
388 branch=$(git rev-parse -q --verify "refs/heads/$1")
389 then
390 head_name="refs/heads/$1"
391 elif branch=$(git rev-parse -q --verify "$1")
392 then
393 head_name="detached HEAD"
394 else
395 usage
399 # Do not need to switch branches, we are already on it.
400 if branch_name=`git symbolic-ref -q HEAD`
401 then
402 head_name=$branch_name
403 branch_name=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
404 else
405 head_name="detached HEAD"
406 branch_name=HEAD ;# detached
408 branch=$(git rev-parse --verify "${branch_name}^0") || exit
410 esac
411 orig_head=$branch
413 # Now we are rebasing commits $upstream..$branch (or with --root,
414 # everything leading up to $branch) on top of $onto
416 # Check if we are already based on $onto with linear history,
417 # but this should be done only when upstream and onto are the same.
418 mb=$(git merge-base "$onto" "$branch")
419 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
420 # linear history?
421 ! (git rev-list --parents "$onto".."$branch" | grep " .* ") > /dev/null
422 then
423 # Lazily switch to the target branch if needed...
424 test -z "$switch_to" || git checkout "$switch_to"
425 echo >&2 "Current branch $branch_name is up to date."
426 exit 0
429 if test -n "$verbose"
430 then
431 echo "Changes from $mb to $onto:"
432 # We want color (if set), but no pager
433 GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
436 # Detach HEAD and reset the tree
437 echo "First, rewinding head to replay your work on top of it..."
438 git checkout -q "$onto^0" || die "could not detach HEAD"
439 git update-ref ORIG_HEAD $branch
441 # If the $onto is a proper descendant of the tip of the branch, then
442 # we just fast forwarded.
443 if test "$mb" = "$branch"
444 then
445 echo >&2 "Fast-forwarded $branch_name to $onto_name."
446 move_to_original_branch
447 exit 0
450 if test -n "$rebase_root"
451 then
452 revisions="$onto..$orig_head"
453 else
454 revisions="$upstream..$orig_head"
457 if test -z "$do_merge"
458 then
459 git format-patch -k --stdout --full-index --ignore-if-in-upstream \
460 $root_flag "$revisions" |
461 git am $git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
462 move_to_original_branch
463 ret=$?
464 test 0 != $ret -a -d "$GIT_DIR"/rebase-apply &&
465 echo $head_name > "$GIT_DIR"/rebase-apply/head-name &&
466 echo $onto > "$GIT_DIR"/rebase-apply/onto &&
467 echo $orig_head > "$GIT_DIR"/rebase-apply/orig-head
468 exit $ret
471 # start doing a rebase with git-merge
472 # this is rename-aware if the recursive (default) strategy is used
474 mkdir -p "$dotest"
475 echo "$onto" > "$dotest/onto"
476 echo "$onto_name" > "$dotest/onto_name"
477 prev_head=$orig_head
478 echo "$prev_head" > "$dotest/prev_head"
479 echo "$orig_head" > "$dotest/orig-head"
480 echo "$head_name" > "$dotest/head-name"
482 msgnum=0
483 for cmt in `git rev-list --reverse --no-merges "$revisions"`
485 msgnum=$(($msgnum + 1))
486 echo "$cmt" > "$dotest/cmt.$msgnum"
487 done
489 echo 1 >"$dotest/msgnum"
490 echo $msgnum >"$dotest/end"
492 end=$msgnum
493 msgnum=1
495 while test "$msgnum" -le "$end"
497 call_merge "$msgnum"
498 continue_merge
499 done
501 finish_rb_merge